// $Id: AAP_init.cpp,v 1.2 2003/12/03 01:52:30 magh Exp $

/*-------------------------------------------------------------------------
 Author: Matthew Galati (magh@lehigh.edu)

 (c) Copyright 2003 Lehigh University. All Rights Reserved.

 This software is licensed under the Common Public License. Please see 
 accompanying file for terms.    
---------------------------------------------------------------------------*/

#include "AAP_init.hpp"
#include "AAP_tm.hpp"
#include "AAP_lp.hpp"
#include "AAP.hpp"

/*---------------------------------------------------*/
USER_initialize * BCP_user_init(){
  //Initialize the USER interface to BCP 
  return new AAP_init;
}

/*---------------------------------------------------*/
BCP_lp_user * AAP_init::lp_init(BCP_lp_prob& p){
  //Initialize the user-defined LP interface to BCP
  return new AAP_lp;
}

/*---------------------------------------------------*/
BCP_tm_user * AAP_init::tm_init(BCP_tm_prob& p,
				const int argnum, 
				const char * const * arglist){

  //Initialize the user-defined TM interface to BCP
  AAP_tm* tm = new AAP_tm;   

  //Read in the TM and LP parameters from the arg ParamFile: parameter file
  tm->tm_par.read_from_arglist(argnum,arglist);
  tm->lp_par.read_from_arglist(argnum,arglist);

  //Read and construct the AAP data instance (a member of TM)
  string datafile(tm->tm_par.entry(AAP_tm_par::AAP_datafile).c_str()); 
  tm->aap = new AAP(datafile);
  
  return tm;
}
