// $Id: AAP_user_data.hpp,v 1.3 2003/12/03 01:52:30 magh Exp $

/* ------------------------------------------------------------------------
 Author: Matthew Galati (magh@lehigh.edu)

 (c) Copyright 2003 Lehigh University. All Rights Reserved.

 This software is licensed under the Common Public License. Please see 
 accompanying file for terms.    
---------------------------------------------------------------------------*/

#ifndef AAP_USER_DATA_H
#define AAP_USER_DATA_H

#include "BCP_USER.hpp"
#include "BCP_buffer.hpp"

#include <vector>
using namespace std;

/*---------------------------------------------------*/
//Class to store extra information to be sent between 
//nodes after branching. In this case, we just store 
//the indices of the (original) variables that were 
//branched on.

class AAP_user_data : public BCP_user_data {
public:
  vector<int> ones;
  vector<int> zeros;

public:
  AAP_user_data() : BCP_user_data() {}
  
  AAP_user_data(vector<int> & ones_, vector<int> & zeros_)
    : BCP_user_data(), ones(ones_), zeros(zeros_) {}
  
  AAP_user_data(BCP_buffer & buf)
    : BCP_user_data(){
    unpack(buf);
  }
  
  AAP_user_data(const AAP_user_data & x)
    : BCP_user_data(), ones(x.ones), zeros(x.zeros) {}

  ~AAP_user_data() {}

public:
  void pack(BCP_buffer & buf) const{
    //Pack the user data
    buf.pack(ones).pack(zeros);
  }

  void unpack(BCP_buffer & buf){
    //Unpack the user data
    buf.unpack(ones).unpack(zeros);
  }

};

#endif
